c=======================================================================
c***********************************************************************
      subroutine wat_limit
c***********************************************************************
c=======================================================================  
      implicit none
c=======================================================================
c     This routine determinates the maximum lai when soil water is 
c     missing. Behaviour is different for grasses, evergreen, cold
c     deciduous or warm deciduous trees
c=======================================================================
 
      include './com_18/parameter.common'
      include './com_18/annee.common'
      include './com_18/bagnum.common'
      include './com_18/carbon_maxi.common'
      include './com_18/ecoin.common'
      include './com_18/lai.common'
      include './com_18/laih2o.common'
      include './com_18/lailim.common'
      include './com_18/loop.common'
      include './com_18/monthcst.common'
      include './com_18/nspc.common'
      include './com_18/pho_sch.common'
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer m
      real*4 ylailim

c-----------------------------------------------

      do ip = ipi, ipf
       if(frac(ip).gt.1.e-7)then

        xleaf_max(ip) = 0.
        ylailim = 0.
        if (ip.gt.nherb) then
         if (idec(ip).eq.0) then
          ylailim=yminlai_w(ip)+0.4*(yvslai_w(ip)-yminlai_w(ip))         
c          ylailim=yminlai_w(ip)+0.8*(yvslai_w(ip)-yminlai_w(ip))
         elseif (idec(ip).eq.1) then
          ylailim=yminlai_w(ip)+0.4*(yvslai_w(ip)-yminlai_w(ip))
c          ylailim=yminlai_w(ip)+0.8*(yvslai_w(ip)-yminlai_w(ip))
         endif
         if(ylailim.lt.yminlai_w(ip)) ylailim = yminlai_w(ip)
        endif
        do m = 1, nm
         if (ip.le.nherb) then
          ylailim= xlai_w(ip,m)
         elseif (idec(ip).eq.2) then
          ylailim=yminlai_w(ip)+0.4*(xlai_w(ip,m)-yminlai_w(ip))
c          ylailim=yminlai_w(ip)+0.8*(xlai_w(ip,m)-yminlai_w(ip))         
          if(ylailim.lt.yminlai_w(ip)) ylailim = yminlai_w(ip)
         endif

         if(nyr_t2.eq.1) ylailim = ylailim0(ip,m)
  
         ylailim0(ip,m) = ylailim
 
         do iday = ini(m),ifin(m)
          carb_max0(ip,iday) = ylailim / splai(ip)
         end do
        end do 
       endif
      enddo

      return
      end subroutine wat_limit