c=======================================================================
c***********************************************************************
      subroutine calrapportprecip(zone,month,r,rapportprecip)
c***********************************************************************
c=======================================================================

c=======================================================================
c   This subroutine calculates the value of precipitation ratio
c=======================================================================
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/pathg.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer kf
c
c-----------------------------------------------      
      real*4 x(2),y(2),valref(101),valobs(101),r,rapportprecip,
     &       rk

      integer i,j,month,k

      character*3 ch  
      character*8 zone
      character*110 filename

      logical flag

      rapportprecip=0.0
      if ((r.ge.0.0).and.(r.le.1.0)) then
         call itochar2(month,ch)
         j=1
90       continue
         if (zone(j:j).ne.' ') then
           j=j+1
           if (j.le.8) goto 90
         endif
         j=j-1 
         call charlen(pathgene,kf)
         filename=pathgene(1:kf)//'ALLSTAT/PRECIP/'//
     &            zone(1:j)//'.'//ch
         inquire(file=filename,EXIST=flag)
         if(flag)then
            open(11,file=filename,status='old')
            do i=1,101
               read(11,95) valref(i),valobs(i) 
            enddo
            close(11)
         else
            valref(1)=0.0
            valobs(1)=0.0
            rk=-0.005
            do k=2,100
               rk=rk+0.01
               valref(k)=rk
               valobs(k)=rk
            enddo
            valref(101)=1.0
            valobs(101)=1.0
         endif
         i=1
91       i=i+1
         if ((r.ge.valobs(i-1)).and.(r.le.valobs(i))) then
            do j=1,2
               x(j)=valref(i-2+j)
               y(j)=valobs(i-2+j)
            enddo
            rapportprecip=(x(1)*y(2)+(x(2)-x(1))*r
     &                   -x(2)*y(1))/(y(2)-y(1))
         else
            goto 91
         endif
      endif
95    format (f8.3,f8.3) 
      return
      end subroutine calrapportprecip