c=======================================================================
c***********************************************************************
      subroutine read_mig
c***********************************************************************
c=======================================================================
c      implicit double precision (a-h,o-z)
      IMPLICIT NONE
      
      include './com_18/parameter.common'
      include './com_18/annee.common'
      include './com_18/coord.common'      
      include './com_18/cte.common'
      include './com_18/disper.common'
      include './com_18/ecoin.common'
      include './com_18/icyr.common'
      include './com_18/inidata.common'
      include './com_18/input_par.common' 
      include './com_18/kernel.common'    
      include './com_18/nspc.common' 
      
      real*8 x,fx
      real*4 aaa,bbb
      integer ip,k,ngt_mig,ihetero
        
      do ngt_mig = 1, n_pix
      
        if(icyr_mig.eq.1) then
      
         read(95,*)aaa,bbb,mig_rate(2,ngt_mig),mig_rate(6,ngt_mig),
     &                mig_rate(8,ngt_mig)
        else
         read(95,*)aaa,bbb,ihetero
         if(isp.eq.6) then
           if(ihetero.eq.1) mig_rate(6,ngt_mig) = 381.106
           if(ihetero.eq.3) mig_rate(6,ngt_mig) = 362.802
           if(ihetero.eq.5) mig_rate(6,ngt_mig) = 353.635
         endif
         if(isp.eq.8) then
           if(ihetero.eq.1) mig_rate(8,ngt_mig) = 450.118
           if(ihetero.eq.3) mig_rate(8,ngt_mig) = 441.491
           if(ihetero.eq.5) mig_rate(8,ngt_mig) = 436.541
         endif
        endif

c       Xmax = 45.*mig_rate(8,ngt_mig) !Xmax = 68.10
c       Xmin(ngt_mig) = 0.
        
        do ip = 1, npft0
        
         if(ip.eq.isp) then
        
c         if(yfrac_ini(ip,ngt_mig).ge.1.e-5) then
          if(
     & (isteady.eq.1.and.yfrac_ini(ip,ngt_mig).ge.1.e-5.and.nyear.eq.2)
     &  .or. 
     & (isteady.eq.0.and.yfrac_ini(ip,ngt_mig).ge.1.e-5.and.nyear.eq.1)
     &  .or.   
     & (isteady.eq.1.and.yfrac_ini(ip,ngt_mig).ge.1.e-7.and.nyear.gt.2)
     &  .or.
     & (isteady.eq.0.and.yfrac_ini(ip,ngt_mig).ge.1.e-7
     &                                        .and.nyear.gt.1)) then
     
            pres(ip,ngt_mig) = 1
            if((isteady.eq.1.and.nyear.eq.2).or.
     &          (isteady.eq.0.and.nyear.eq.1)) then
              do k = 1, n_nghmx
                pres_side(ip,k,ngt_mig) = 1
                prop(ip,k,ngt_mig) = 90000.
                count(ip,k,ngt_mig) = 0 ! MARIE
                prop_time(ip,k,ngt_mig) = 0
              enddo
              seed_persistence(ngt_mig) = 0
            endif  
          else
            if(nyear.eq.1) then
              pres(ip,ngt_mig) = 0
              do k = 1, n_nghmx
                pres_side(ip,k,ngt_mig) = 0
                prop(ip,k,ngt_mig) = 0.
                count(ip,k,ngt_mig) = 0 ! MARIE
                prop_time(ip,k,ngt_mig) = 0
              enddo
              seed_persistence(ngt_mig) = 0
            else  
            if(pres(ip,ngt_mig).eq.1) then ! MARIE
              seed_persistence(ngt_mig) = seed_persistence(ngt_mig) + 1
              if(seed_persistence(ngt_mig).le.3) then
                 pres(ip,ngt_mig) = 1
              else       
                 pres(ip,ngt_mig) = 0
                 do k = 1, n_nghmx
                   pres_side(ip,k,ngt_mig) = 0
                   prop(ip,k,ngt_mig) = 0.
                   count(ip,k,ngt_mig) = 0 ! MARIE
                   prop_time(ip,k,ngt_mig) = 0
                 enddo
                 seed_persistence(ngt_mig) = 0
              endif
            else         
              pres(ip,ngt_mig) = 0
              do k = 1, n_nghmx
                pres_side(ip,k,ngt_mig) = 0
                prop(ip,k,ngt_mig) = 0.
                count(ip,k,ngt_mig) = 0 ! MARIE
                prop_time(ip,k,ngt_mig) = 0
              enddo
            endif 
            endif  
          endif
      
          pres_new(ip,ngt_mig) = 0      
                
          do k = 1, n_nghmx
            preside_new(ip,k,ngt_mig) = 0
          enddo
          
         else
          
          if(
     & (isteady.eq.1.and.yfrac_ini(ip,ngt_mig).ge.1.e-5.and.nyear.eq.2)
     &  .or. 
     & (isteady.eq.0.and.yfrac_ini(ip,ngt_mig).ge.1.e-5.and.nyear.eq.1)
     &  .or.   
     & (isteady.eq.1.and.yfrac_ini(ip,ngt_mig).ge.1.e-7.and.nyear.gt.2)
     &  .or.
     & (isteady.eq.0.and.yfrac_ini(ip,ngt_mig).ge.1.e-7
     &                                        .and.nyear.gt.1)) then
     
            pres(ip,ngt_mig) = 1
            pres_new(ip,ngt_mig) = 1
            
          else
            pres(ip,ngt_mig) = 0
            pres_new(ip,ngt_mig) = 0
          endif
          
         endif
          
        enddo  

        if(nyear.eq.1.and.imig_rd.eq.1) then
        
        read(176,*)aaa,bbb,(prop(isp,k,ngt_mig),k=1,n_nghmx),
     &                      (prop_time(isp,k,ngt_mig),k=1,n_nghmx)
        do k = 1, n_nghmx
          count(isp,k,ngt_mig) = prop_time(isp,k,ngt_mig)
        enddo
                
        read(177,*)aaa,bbb,(pres_side(isp,k,ngt_mig),k=1,n_nghmx)
        read(178,*)(pres(ip,ngt_mig),ip=1,npft0)
        
        endif
        
      enddo 
                
      return
      end subroutine read_mig