c=======================================================================
c***********************************************************************
      subroutine frac_herbs(ngt)
c***********************************************************************
c=======================================================================
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/annppf.common'
      include './com_18/ecoin.common'
      include './com_18/landuse.common'
      include './com_18/mois.common'
      include './com_18/nspc.common'

      
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer , intent(in) :: ngt
      
      integer ip
      real*4 herb_suc
      
c-----------------------------------------------
c=======================================================================
c   ynppf represents an annual npp 
c   if it is negative, it is set to 0 : an herb with 
c   a negative annual npp is considered as inexistant
c=======================================================================

      herb_suc = 0.
      do ip = 1, nherb+nbush 
        if ((suc_est(ip,ngt).gt.1.e-5).and.(ynppf(ip).gt.1.e-5)) then
          herb_suc = herb_suc + suc_est(ip,ngt)*ynppf(ip)
        endif
      enddo 

      do ip = 1, nherb+nbush
        if ((suc_est(ip,ngt).gt.1.e-5).and.(ynppf(ip).gt.1.e-5)) then
          frac(ip) = suc_est(ip,ngt)*frac_nat(ngt)*ynppf(ip)/herb_suc
        else
          frac(ip) = 0.
        endif

      enddo

      return
      end subroutine frac_herbs