c=======================================================================
c***********************************************************************
      subroutine printing(ipr,time,y,drv)
c***********************************************************************
c=======================================================================

c      implicit double precision (a-h,o-z)
      implicit none

      include './com_18/parameter.common'
      include './com_18/coord.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/eco.common'
      include './com_18/files_ibm.common'
      include './com_18/flux_w.common'
      include './com_18/iprt.common'
      include './com_18/monthcst.common'      
      include './com_18/monwat.common'
      include './com_18/nspc.common'
      include './com_18/prt.common'
      include './com_18/prt_ctrl.common'
      include './com_18/smrd.common'
      include './com_18/varnow.common'
      include './com_18/vegfr.common'
      include './com_18/waflux.common'
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer iday,idnn,ip,ipr,k,km,m,nr,ny0
      real*8  dn,drv,eiry,time,wbudy,y
c
c-----------------------------------------------

      integer npint,ijour
      character*10 mois(nm)
      character*100 formatw
      dimension y(nequat),drv(nequat)
     

      data mois /'JANUARY','FEBRUARY','MARCH','APRIL','MAY','JUNE'
     1    ,'JULY','AUGUST','SEPTEMBER','OCTOBER','NOVEMBER','DECEMBER'/


      ny0 = int(time/float(nd)+0.000001)+1
      dn  = time - float(ny0-1) * float(nd)

      if (idaily_out.eq.0) then
        npint=nm
        do m = 1, nm
          mdur(m) = mlength(m)
        end do
      else
        npint=nd
        do iday = 1, nd
          mdur(iday)=1
        end do
      endif

c begins operations performed once a year (January 1st)
      if (ny0.ne.ny0prv) then


         open(29,file=filtim)
         write(29,*)'igr:',igr
         write(29,*)'ny0:',ny0,'    nyear:',nyear
         close(29)


         nprt=nstprt-1

         if (nsyr.gt.0) then

               prcy = float(nd)*prcy/nsyr
               runy = float(nd)*runy/nsyr
               soey = float(nd)*soey/nsyr
               svey = float(nd)*svey/nsyr
               pety = float(nd)*pety/nsyr
               sney = float(nd)*sney/nsyr

               do k=1,npint
                  swmth(k)  = swmth(k) / nsmth(k)
		  swmmmth(k)  = swmmmth(k) / nsmth(k)
                  rtrmth(k) = rtrmth(k) / nsmth(k)
                  petmth(k) = petmth(k) * mdur(k) / nsmth(k)
                  aetmth(k) = aetmth(k) * mdur(k) / nsmth(k)
                  runmth(k) = runmth(k) * mdur(k) / nsmth(k)
		  srunmth(k) = srunmth(k) * mdur(k) / nsmth(k)
                  drnmth(k) = drnmth(k) * mdur(k) / nsmth(k)
                  svemth(k) = svemth(k) * mdur(k) / nsmth(k)
		  eintmth(k) = eintmth(k) * mdur(k) / nsmth(k)
		  etrmth(k) = etrmth(k) * mdur(k) / nsmth(k)
		  esomth(k) = esomth(k) * mdur(k) / nsmth(k)
                  rblmth(k) = rblmth(k) / nsmth(k)
                  albmth(k) = albmth(k) / nsmth(k)
                  albsvmth(k) = albsvmth(k) / nsmth(k)
                  albsmth(k) = albsmth(k) / nsmth(k)
                  albvmth(k) = albvmth(k) / nsmth(k)
                  emimth(k) = emimth(k) / nsmth(k)
		  eminsmth(k) = eminsmth(k) / nsmth(k)
		  z0mth(k) = z0mth(k) / nsmth(k)
                  rnmth(k)  = rnmth(k) / nsmth(k)
                  firdmth(k) = firdmth(k) / nsmth(k)
                  xhmth(k)  = xhmth(k) / nsmth(k)
                  xlemth(k) = xlemth(k) / nsmth(k)
                  solmth(k) = solmth(k) / nsmth(k)
                  sfmth(k)  = sfmth(k) * mdur(k) / nsmth(k)
                  snemth(k) = snemth(k) * mdur(k) / nsmth(k)
                  smlmth(k) = smlmth(k) * mdur(k) / nsmth(k)
                  grfmth(k) = grfmth(k) / nsmth(k)
                  tsmth(k)  = tsmth(k) / nsmth(k)
                  fgsmth(k) = fgsmth(k) / nsmth(k)
                  fsnmth(k) = fsnmth(k) / nsmth(k)
		  sndmth(k) = sndmth(k) / nsmth(k)
                  tlamth(k) = tlamth(k) / nsmth(k)
               enddo 

         endif

         if (ny0.eq.ny0max+1) then
             if (iyprt.ge.1) then 
	     
	       

               if(iprt_sw.eq.1) 
     &            write(31,131) ylongi,ylati,(swmth(k),k=1,npint)
               if(iprt_swmm.eq.1) 
     &            write(531,631) ylongi,ylati,(swmmmth(k),k=1,npint)     
               if(iprt_rtr.eq.1) 
     &            write(532,131) ylongi,ylati,(rtrmth(k),k=1,npint)     
               if(iprt_pet.eq.1) 
     &            write(32,401) ylongi,ylati,(petmth(k),k=1,npint)
               if(iprt_aet.eq.1) 
     &            write(33,401) ylongi,ylati,(aetmth(k),k=1,npint)
               if(iprt_run.eq.1) 
     &            write(34,401) ylongi,ylati,(runmth(k),k=1,npint)
               if(iprt_fsn.eq.1) 
     &            write(35,131) ylongi,ylati,(fsnmth(k),k=1,npint)
               if(iprt_snd.eq.1) 
     &            write(535,135) ylongi,ylati,(sndmth(k),k=1,npint)
               if(iprt_srun.eq.1) 
     &            write(536,401) ylongi,ylati,(srunmth(k),k=1,npint)          
               if(iprt_drn.eq.1) 
     &            write(36,401) ylongi,ylati,(drnmth(k),k=1,npint)
               if(iprt_sve.eq.1) 
     &            write(37,401) ylongi,ylati,(svemth(k),k=1,npint)
               if(iprt_eint.eq.1) 
     &            write(537,401) ylongi,ylati,(eintmth(k),k=1,npint) 
               if(iprt_etr.eq.1) 
     &            write(538,401) ylongi,ylati,(etrmth(k),k=1,npint)
               if(iprt_eso.eq.1) 
     &            write(539,401) ylongi,ylati,(esomth(k),k=1,npint)              
               if(iprt_rbl.eq.1) 
     &            write(38,401) ylongi,ylati,(rblmth(k),k=1,npint)
               if(iprt_alb.eq.1) 
     &            write(39,131) ylongi,ylati,(albmth(k),k=1,npint)
               if(iprt_albsv.eq.1) 
     &            write(239,131) ylongi,ylati,(albsvmth(k),k=1,npint)
               if(iprt_albs.eq.1) 
     &            write(339,131) ylongi,ylati,(albsmth(k),k=1,npint)
               if(iprt_albv.eq.1) 
     &            write(439,131) ylongi,ylati,(albvmth(k),k=1,npint)
               if(iprt_rn.eq.1) 
     &            write(40,401) ylongi,ylati,(rnmth(k),k=1,npint)
               if(iprt_grf.eq.1) 
     &            write(41,401) ylongi,ylati,(grfmth(k),k=1,npint)
               if(iprt_ts.eq.1) 
     &            write(42,132) ylongi,ylati,(tsmth(k),k=1,npint)
               if(iprt_fgs.eq.1) 
     &            write(43,131) ylongi,ylati,(fgsmth(k),k=1,npint)
               if(iprt_lai.eq.1) 
     &            write(44,1200) ylongi,ylati,(tlamth(k),k=1,npint)
               if(iprt_fird.eq.1) 
     &            write(45,401) ylongi,ylati,(firdmth(k),k=1,npint)
               if(iprt_xh.eq.1) 
     &            write(46,401) ylongi,ylati,(xhmth(k),k=1,npint)
               if(iprt_xle.eq.1) 
     &            write(47,401) ylongi,ylati,(xlemth(k),k=1,npint)
               if(iprt_sol.eq.1) 
     &            write(48,401) ylongi,ylati,(solmth(k),k=1,npint)
               if(iprt_sf.eq.1) 
     &            write(49,401) ylongi,ylati,(sfmth(k),k=1,npint)
               if(iprt_sne.eq.1) 
     &            write(50,401) ylongi,ylati,(snemth(k),k=1,npint)
               if(iprt_sml.eq.1) 
     &            write(51,401) ylongi,ylati,(smlmth(k),k=1,npint)
               if(iprt_emi.eq.1) 
     &            write(52,131) ylongi,ylati,(emimth(k),k=1,npint)
               if(iprt_emins.eq.1) 
     &            write(152,131) ylongi,ylati,(eminsmth(k),k=1,npint)
               if(iprt_z0.eq.1) 
     &            write(252,131) ylongi,ylati,(z0mth(k),k=1,npint)


c            eiry = interception of rainfall by vegetation
               eiry=soey-svey   
               wbudy = prcy-runy-soey-sney

               if(iprt_yr.eq.1) write(30,125)igr,ylongi,ylati,
     1                fsi,fci,wpi,rootd,prcy,runy
     2                ,svey,eiry,sney,pety,wbudy,aswmin,fveg
               if(iprt_frc.eq.1) then
	          write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f12.8))'
	          write(530,formatw),ylongi,ylati,(frc(ip),ip=1,npft)
               endif
             endif

         endif

         do nr = 1,nres
            sumnet(nr) = 0.
         enddo

         nsyr = 0
         do k=1,npint
            nsmth(k) = 0
         enddo
        
         prcy=0.
         runy=0.
         soey=0.
         svey=0.
         pety=0.
         sney=0.
         do k=1,npint
            swmth(k) = 0.
	    swmmmth(k) = 0.
            rtrmth(k) = 0.
            petmth(k) = 0.
            aetmth(k) = 0.
            runmth(k) = 0.
	    srunmth(k) = 0.
            drnmth(k) = 0.
            svemth(k) = 0.
	    eintmth(k) = 0.
	    etrmth(k) = 0.
	    esomth(k) = 0.
            rblmth(k) = 0.
            albmth(k) = 0.
            albsvmth(k) = 0.
            albsmth(k) = 0.
            albvmth(k) = 0.
            emimth(k) = 0.
            eminsmth(k) = 0.
            z0mth(k) = 0.
            rnmth(k) = 0.
            grfmth(k) = 0.
            tsmth(k) = 0.
            fgsmth(k) = 0.
            fsnmth(k) = 0.
	    sndmth(k) = 0.
            tlamth(k) = 0.
            firdmth(k) = 0.
            xhmth(k) = 0.
            xlemth(k) = 0.
            solmth(k) = 0.
            sfmth(k) = 0.
            snemth(k) = 0.
            smlmth(k) = 0.
         enddo

      endif

c begins operations performed every time step
      ny0prv = ny0
      nprt = nprt + 1

      idnn = int(dn+1.00001)
      km=0
 500  km=km+1
      if(idnn.gt.mdur(km))then
         idnn=idnn-mdur(km)
         goto 500
      endif

      nsyr = nsyr+1
      nsmth(km) = nsmth(km)+1

      prcy = prcy + preci
      runy = runy + drun+srun
      soey = soey + soe
      svey = svey + svevp
      pety = pety + pet
      sney = sney + sne
       
      swmth(km) = swmth(km) + asw
      swmmmth(km) = swmmmth(km) + (wpi + asw*(fci-wpi))      
      rtrmth(km) = rtrmth(km) + rtrans      
      petmth(km) = petmth(km) + pet
      aetmth(km) = aetmth(km) + aet
      runmth(km) = runmth(km) + drun+srun
      srunmth(km) = srunmth(km) + srun
      drnmth(km) = drnmth(km) + drun
      svemth(km) = svemth(km) + svevp
      eintmth(km) = eintmth(km) + (aet-svevp-sne)
      etrmth(km) = etrmth(km) + rtrans*svevp
      esomth(km) = esomth(km) + (1.-rtrans)*svevp
      rblmth(km) = rblmth(km) + rblwm
      albmth(km) = albmth(km) + alb
      albsvmth(km) = albsvmth(km) + albsv
      albsmth(km) = albsmth(km) + albsoil
      albvmth(km) = albvmth(km) + albvege
      emimth(km) = emimth(km) + emisf
      eminsmth(km) = eminsmth(km) + emisfns
      z0mth(km) = z0mth(km) + z0tot
      rnmth(km) = rnmth(km) + rnet
      grfmth(km) = grfmth(km) + grflx
      tsmth(km) = tsmth(km) + ts
      fgsmth(km) = fgsmth(km) + fgs
      fsnmth(km) = fsnmth(km) + fsn
      sndmth(km) = sndmth(km) + snd
      tlamth(km) = tlamth(km) + tlai
      firdmth(km) = firdmth(km) + fird
      xhmth(km) = xhmth(km) + xh
      xlemth(km) = xlemth(km) + axle
      solmth(km) = solmth(km) + solg(0)
      sfmth(km) = sfmth(km) + sf
      snemth(km) = snemth(km) + sne
      smlmth(km) = smlmth(km) + sml      
        

c begins full printing if ifull eq 1
c operations are performed every nstprt time steps, but only over 
c the last ny0prt years

      if (ifull.eq.1) then
         if ((ny0.ge.(ny0max-ny0prt+1)).and.(nprt.eq.nstprt)) then
            nprt = 0
            write(ipr,100) ny0,dn,mois(km),idnn

               write(ipr,1101) igr
               write(ipr,101) ylongi,ylati,temi
     &                       ,delti,preci,asw,solg(0)
               write(ipr,102) (y(k),k=1,nres)
               write(ipr,102) (drv(k),k=1,nres)
               write(ipr,102) (fin_w(k),k=1,nres)
               write(ipr,102) (fout_w(k),k=1,nres)
               write(ipr,105) fsi,fci,wpi,pet,soe
     &                       ,drun,srun,sne
               write(ipr,106) ts,hai,windi,tlai,alb
     &                 ,rnet,grflx,rblwm

         endif
      endif

 1101 format(1x,'STATION No',i6)
  100 format(1x,'YEAR=',I4,'   DAY NUMBER=',F6.2,6X,A10,I2)
  101 format(1x,f6.1,1x,f6.1,1x,f5.1,1x,f6.2,1x,f7.3,1x,f7.4,1x,f7.2)
  102 format(2(1x,d12.5))
  105 format(1x,3(1x,f7.2),5(1x,f7.3),2(1x,i3))
  106 format(1x,f6.2,1x,f6.3,2(1x,f5.2),1x,f6.3,3(1x,f6.1))
  115 format(1x,i4,1x,f5.1,1x,f6.1,f7.1,2(1x,i3))
  125 format(i6,2(1x,f8.3),4(1x,f7.2),2(1x,f8.2),4(1x,f7.2)
     &      ,1x,f8.2,2(1x,f6.3))
  131 format(2(1x,f8.3),366(1x,f7.4))
  631 format(2(1x,f8.3),366(1x,f8.2))
  132 format(2(1x,f8.3),366(1x,f6.2))
  135 format(2(1x,f8.3),366(1x,f9.0))  
  401 format(2(1x,f8.3),366(1x,1pe10.3))
 1200 format(2(1x,f8.3),366(1x,f4.1))

      return
      end